---
slug: working-with-qibullet-sim-and-naoqi-emb
title: Working with the QiBullet Simulation and NaoQi Embodiment AAAMBOS packages
authors: fschroeder
tags: [subprocess, qibullet, naoqi, aaambos, simulation, robot, tutorial]
---
import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';
import CodeBlock from '@theme/CodeBlock';

## Subprocess Problem
Using the `qibullet-sim` or `naoqi-embodiment` modules is different. Both require a different Python version than AAAMBOS (3.9 and 2.7 vs 3.10).
Our solution is that we put the library calls into a subprocess and the modules communicate with them via the stdin and stdout-put pipes.
This results in an additional overhead in the development process. But we tried to come up with a at least handy solution.

### The Subprocess
<Tabs groupId="module">
<TabItem value="qibullet" label="QiBullet" default>
The subprocess in the qibullet_simulation module executes the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_qibullet_simulation/-/blob/main/qibullet_simulation/modules/run_sim_39.sh?ref_type=heads"><code>run_sim_39.sh</code></a> shell script.
 It needs 4 arguments to call it:
<ol>
<li>The path to the conda shell script</li>
<li>Conda environment name</li>
<li>Robot name, e.g., "pepper", "nao"</li>
<li>Path to the exchange directory. (e.g., for images)</li>
</ol>
E.g.,<br/><br/>
<CodeBlock language="bash">
{`sh run_sim_39.sh "/home/USER/miniconda3/etc/profile.d/conda.sh" qibullet pepper .`}
</CodeBlock>

The python script that is started is the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_qibullet_simulation/-/blob/main/qibullet_simulation/modules/simulator_py39.py?ref_type=heads"><code>simulator_py39.py</code></a>
The python script is for python 3.9. So the match statement is not available.
</TabItem>
<TabItem value="naoqi" label="NaoQi">
The subprocess in the NaoQi Embodiment module executes the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_naoqi_robot_embodiment/-/blob/main/naoqi_robot_embodiment/modules/run_sim_27.sh?ref_type=heads"><code>run_sim_27.sh</code></a> shell script.
It needs 5 arguments to call it:
<ol>
<li>The path to the conda shell script </li>
<li>Conda environment name</li>
<li>The path to the naoqi library site-packages <code>..../naoqi/lib/python2.7/site-packages</code></li>
<li>Robot name, e.g., "pepper", "nao"</li>
<li>The ip address of the robot</li>
</ol>
     
E.g.,<br/><br/>
<CodeBlock language="bash">
{`sh run_sim_39.sh "/home/USER/miniconda3/etc/profile.d/conda.sh" py27 "/home/USER/miniconda3/envs/py27/lib/python2.7/site-packages/naoqi/lib/python2.7/site-packages" pepper 192.168.178.40`}
</CodeBlock>

The python script that is started is the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_naoqi_robot_embodiment/-/blob/main/naoqi_robot_embodiment/modules/backend_py27.py?ref_type=heads"><code>backend_py27.py</code></a>
It is a python 2.7 script, e.g., print(s) does nor contain parentheses.
</TabItem>
</Tabs>

### The Module
<Tabs groupId="module">
<TabItem value="qibullet" label="QiBullet" default>
The AAAMBOS module that starts the subprocess is inside the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_qibullet_simulation/-/blob/main/qibullet_simulation/modules/qibullet_sim.py?ref_type=heads"><code>qibullet_sim.py</code></a>)
</TabItem>
<TabItem value="naoqi" label="NaoQi">
The AAAMBOS module that starts the subprocess is inside the <a href="https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_naoqi_robot_embodiment/-/blob/main/naoqi_robot_embodiment/modules/naoqi_backend.py?ref_type=heads"><code>naoqi_backend.py</code></a>
</TabItem>
</Tabs>


## From the Module to the Subprocess
<Tabs groupId="module">
<TabItem value="qibullet" label="QiBullet" default>
You can send a message to the subprocess from the module via the extension:<br/><br/>
<CodeBlock language="python">
{`await self.subprocess.msg_subprocess(\{"topic": "moveTo", "msg": \{"x": 0.5, "y": 0.5, "theta": 0.0\}\})`}
</CodeBlock>
Receiving that message is done in the <code>simulator_py39.py</code> in the <code>msg_callback</code> method
</TabItem>
<TabItem value="naoqi" label="NaoQi">
You can send a message to the subprocess from the module via the extension:<br/><br/>
<CodeBlock langauge="python">
{`await self.subprocess.msg_subprocess(\{"topic": "say", "msg": \{"text": f"Hallo Du da!"\}\})`}
</CodeBlock>
Receiving that message is done in the <code>backend_py27.py</code> in the <code>callback</code> method.
</TabItem>
</Tabs>


## From the Subprocess to the Module
<Tabs groupId="module">
<TabItem value="qibullet" label="QiBullet" default>
You can send a message from the subprocess to the module via the <code>send_msg</code>:<br/><br/>
<CodeBlock language="python">
{`self.send_msg("position", {"time": datetime.now().isoformat(), "x": x, "y": y, "theta": theta})`}
</CodeBlock><br/>
Receiving that message is done in the <code>qibullet_sim.py</code> in the <code>sim_callback</code> method
</TabItem>
<TabItem value="naoqi" label="NaoQi">
You can send a message from the subprocess to the module via the method <code>send_msg</code>:<br/><br/>
<CodeBlock language="python">
{`self.send_msg("info", {"i": "started"})`}
</CodeBlock>
Receiving that message is done in the <code>naoqi_backend.py</code> in the <code>sim_callback</code> method.
</TabItem>
</Tabs>
